import { SvelteComponent, init, safe_not_equal, svg_element, attr, insert, append, detach, empty, noop } from 'svelte/internal';

/* src\fa.svelte generated by Svelte v3.6.11 */

// (104:0) {#if i[4]}
function create_if_block(ctx) {
	var svg, g1, g0, svg_viewBox_value;

	function select_block_type(ctx) {
		if (typeof ctx.i[4] == 'string') return create_if_block_1;
		return create_else_block;
	}

	var current_block_type = select_block_type(ctx);
	var if_block = current_block_type(ctx);

	return {
		c() {
			svg = svg_element("svg");
			g1 = svg_element("g");
			g0 = svg_element("g");
			if_block.c();
			attr(g0, "transform", ctx.transform);
			attr(g1, "transform", "translate(256 256)");
			attr(svg, "id", ctx.id);
			attr(svg, "class", ctx.clazz);
			attr(svg, "style", ctx.s);
			attr(svg, "viewBox", svg_viewBox_value = `0 0 ${ctx.i[0]} ${ctx.i[1]}`);
			attr(svg, "aria-hidden", "true");
			attr(svg, "role", "img");
			attr(svg, "xmlns", "http://www.w3.org/2000/svg");
		},

		m(target, anchor) {
			insert(target, svg, anchor);
			append(svg, g1);
			append(g1, g0);
			if_block.m(g0, null);
		},

		p(changed, ctx) {
			if (current_block_type === (current_block_type = select_block_type(ctx)) && if_block) {
				if_block.p(changed, ctx);
			} else {
				if_block.d(1);
				if_block = current_block_type(ctx);
				if (if_block) {
					if_block.c();
					if_block.m(g0, null);
				}
			}

			if (changed.transform) {
				attr(g0, "transform", ctx.transform);
			}

			if (changed.id) {
				attr(svg, "id", ctx.id);
			}

			if (changed.clazz) {
				attr(svg, "class", ctx.clazz);
			}

			if (changed.s) {
				attr(svg, "style", ctx.s);
			}

			if ((changed.i) && svg_viewBox_value !== (svg_viewBox_value = `0 0 ${ctx.i[0]} ${ctx.i[1]}`)) {
				attr(svg, "viewBox", svg_viewBox_value);
			}
		},

		d(detaching) {
			if (detaching) {
				detach(svg);
			}

			if_block.d();
		}
	};
}

// (124:8) {:else}
function create_else_block(ctx) {
	var path0, path0_d_value, path0_fill_value, path0_fill_opacity_value, path1, path1_d_value, path1_fill_value, path1_fill_opacity_value;

	return {
		c() {
			path0 = svg_element("path");
			path1 = svg_element("path");
			attr(path0, "d", path0_d_value = ctx.i[4][0]);
			attr(path0, "fill", path0_fill_value = ctx.secondaryColor || ctx.color || 'currentColor');
			attr(path0, "fill-opacity", path0_fill_opacity_value = ctx.swapOpacity != false ? ctx.primaryOpacity : ctx.secondaryOpacity);
			attr(path0, "transform", "translate(-256 -256)");
			attr(path1, "d", path1_d_value = ctx.i[4][1]);
			attr(path1, "fill", path1_fill_value = ctx.primaryColor || ctx.color || 'currentColor');
			attr(path1, "fill-opacity", path1_fill_opacity_value = ctx.swapOpacity != false ? ctx.secondaryOpacity : ctx.primaryOpacity);
			attr(path1, "transform", "translate(-256 -256)");
		},

		m(target, anchor) {
			insert(target, path0, anchor);
			insert(target, path1, anchor);
		},

		p(changed, ctx) {
			if ((changed.i) && path0_d_value !== (path0_d_value = ctx.i[4][0])) {
				attr(path0, "d", path0_d_value);
			}

			if ((changed.secondaryColor || changed.color) && path0_fill_value !== (path0_fill_value = ctx.secondaryColor || ctx.color || 'currentColor')) {
				attr(path0, "fill", path0_fill_value);
			}

			if ((changed.swapOpacity || changed.primaryOpacity || changed.secondaryOpacity) && path0_fill_opacity_value !== (path0_fill_opacity_value = ctx.swapOpacity != false ? ctx.primaryOpacity : ctx.secondaryOpacity)) {
				attr(path0, "fill-opacity", path0_fill_opacity_value);
			}

			if ((changed.i) && path1_d_value !== (path1_d_value = ctx.i[4][1])) {
				attr(path1, "d", path1_d_value);
			}

			if ((changed.primaryColor || changed.color) && path1_fill_value !== (path1_fill_value = ctx.primaryColor || ctx.color || 'currentColor')) {
				attr(path1, "fill", path1_fill_value);
			}

			if ((changed.swapOpacity || changed.secondaryOpacity || changed.primaryOpacity) && path1_fill_opacity_value !== (path1_fill_opacity_value = ctx.swapOpacity != false ? ctx.secondaryOpacity : ctx.primaryOpacity)) {
				attr(path1, "fill-opacity", path1_fill_opacity_value);
			}
		},

		d(detaching) {
			if (detaching) {
				detach(path0);
				detach(path1);
			}
		}
	};
}

// (118:8) {#if typeof i[4] == 'string'}
function create_if_block_1(ctx) {
	var path, path_d_value, path_fill_value;

	return {
		c() {
			path = svg_element("path");
			attr(path, "d", path_d_value = ctx.i[4]);
			attr(path, "fill", path_fill_value = ctx.color || ctx.primaryColor || 'currentColor');
			attr(path, "transform", "translate(-256 -256)");
		},

		m(target, anchor) {
			insert(target, path, anchor);
		},

		p(changed, ctx) {
			if ((changed.i) && path_d_value !== (path_d_value = ctx.i[4])) {
				attr(path, "d", path_d_value);
			}

			if ((changed.color || changed.primaryColor) && path_fill_value !== (path_fill_value = ctx.color || ctx.primaryColor || 'currentColor')) {
				attr(path, "fill", path_fill_value);
			}
		},

		d(detaching) {
			if (detaching) {
				detach(path);
			}
		}
	};
}

function create_fragment(ctx) {
	var if_block_anchor;

	var if_block = (ctx.i[4]) && create_if_block(ctx);

	return {
		c() {
			if (if_block) if_block.c();
			if_block_anchor = empty();
		},

		m(target, anchor) {
			if (if_block) if_block.m(target, anchor);
			insert(target, if_block_anchor, anchor);
		},

		p(changed, ctx) {
			if (ctx.i[4]) {
				if (if_block) {
					if_block.p(changed, ctx);
				} else {
					if_block = create_if_block(ctx);
					if_block.c();
					if_block.m(if_block_anchor.parentNode, if_block_anchor);
				}
			} else if (if_block) {
				if_block.d(1);
				if_block = null;
			}
		},

		i: noop,
		o: noop,

		d(detaching) {
			if (if_block) if_block.d(detaching);

			if (detaching) {
				detach(if_block_anchor);
			}
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { class: clazz = '', id = '', style = '', icon, fw = false, flip = false, pull = false, rotate = false, size = false, color, primaryColor, secondaryColor, primaryOpacity = 1, secondaryOpacity = 0.4, swapOpacity = false } = $$props;

let i;
let s;
let transform;

	$$self.$set = $$props => {
		if ('class' in $$props) $$invalidate('clazz', clazz = $$props.class);
		if ('id' in $$props) $$invalidate('id', id = $$props.id);
		if ('style' in $$props) $$invalidate('style', style = $$props.style);
		if ('icon' in $$props) $$invalidate('icon', icon = $$props.icon);
		if ('fw' in $$props) $$invalidate('fw', fw = $$props.fw);
		if ('flip' in $$props) $$invalidate('flip', flip = $$props.flip);
		if ('pull' in $$props) $$invalidate('pull', pull = $$props.pull);
		if ('rotate' in $$props) $$invalidate('rotate', rotate = $$props.rotate);
		if ('size' in $$props) $$invalidate('size', size = $$props.size);
		if ('color' in $$props) $$invalidate('color', color = $$props.color);
		if ('primaryColor' in $$props) $$invalidate('primaryColor', primaryColor = $$props.primaryColor);
		if ('secondaryColor' in $$props) $$invalidate('secondaryColor', secondaryColor = $$props.secondaryColor);
		if ('primaryOpacity' in $$props) $$invalidate('primaryOpacity', primaryOpacity = $$props.primaryOpacity);
		if ('secondaryOpacity' in $$props) $$invalidate('secondaryOpacity', secondaryOpacity = $$props.secondaryOpacity);
		if ('swapOpacity' in $$props) $$invalidate('swapOpacity', swapOpacity = $$props.swapOpacity);
	};

	$$self.$$.update = ($$dirty = { icon: 1, fw: 1, pull: 1, size: 1, style: 1, flip: 1, rotate: 1 }) => {
		if ($$dirty.icon) { $$invalidate('i', i = (icon && icon.icon) || [0, 0, '', [], '']); }
		if ($$dirty.fw || $$dirty.pull || $$dirty.size || $$dirty.style) { {
      let float;
      let width;
      const height = '1em';
      let lineHeight;
      let fontSize;
      let textAlign;
      let verticalAlign = '-.125em';
      const overflow = 'visible';
    
      if (fw) {
        textAlign = 'center';
        width = '1.25em';
      }
    
      if (pull) {
        float = pull;
      }
    
      if (size) {
        if (size == 'lg') {
          fontSize = '1.33333em';
          lineHeight = '.75em';
          verticalAlign = '-.225em';
        } else if (size == 'xs') {
          fontSize = '.75em';
        } else if (size == 'sm') {
          fontSize = '.875em';
        } else {
          fontSize = size.replace('x', 'em');
        }
      }
    
      const styleObj = {
        float,
        width,
        height,
        'line-height': lineHeight,
        'font-size': fontSize,
        'text-align': textAlign,
        'vertical-align': verticalAlign,
        overflow,
      };
      let styleStr = '';
      for (const prop in styleObj) {
        if (styleObj[prop]) {
          styleStr += `${prop}:${styleObj[prop]};`;
        }
      }
      $$invalidate('s', s = `${styleStr};${style}`);
    } }
		if ($$dirty.flip || $$dirty.rotate) { {
      let t = '';
    
      if (flip) {
        let flipX = 1;
        let flipY = 1;
        if (flip == 'horizontal') {
          flipX = -1;
        } else if (flip == 'vertical') {
          flipY = -1;
        } else {
          flipX = flipY = -1;
        }
        t += ` scale(${flipX} ${flipY})`;
      }
    
      if (rotate) {
        t += ` rotate(${rotate} 0 0)`;
      }
    
      $$invalidate('transform', transform = t);
    } }
	};

	return {
		clazz,
		id,
		style,
		icon,
		fw,
		flip,
		pull,
		rotate,
		size,
		color,
		primaryColor,
		secondaryColor,
		primaryOpacity,
		secondaryOpacity,
		swapOpacity,
		i,
		s,
		transform
	};
}

class Fa extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, ["class", "id", "style", "icon", "fw", "flip", "pull", "rotate", "size", "color", "primaryColor", "secondaryColor", "primaryOpacity", "secondaryOpacity", "swapOpacity"]);
	}
}

export default Fa;
